	SUBROUTINE GRADFUN(FUN,GFUN,MY,LMF,NRAD,H,R,DR,S)
************************************************************
*  Computes gradient of the function expanded in spherical *
*  harmonics within a muffin-tin sphere.                   *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_GAUNT  ,ONLY: C                                 !!! from makegnt
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 FUN(0:NRADMEM,LIMVMEM),GFUN(0:NRADMEM,LIMVMEM)
     &   ,DFUNDR(0:NRADMEM),CGNT
	DIMENSION R(0:NRAD),DR(0:NRAD)
	DATA PI/3.141592653589793D0/
C START CODE
      SQPI43=SQRT(4.D0*PI/3.D0)
      DO L=0,LMF
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD
      GFUN(IRAD,LM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      DO L=0,LMF                       !!! over l
      DO M=-L,L                        !!! over m
      LM=L*(L+1)+M+1
      IF(L.GT.0.AND.(L-1).GE.ABS(M-MY))THEN
      LMY=L*(L-1)+M-MY+1
      CGNT=C(0,LM,LMY)*SQPI43*(0.D0,-1.D0)
	CALL CDERIV1(FUN(0,LMY),DFUNDR(0),NRAD,H,R(0),DR(0),S)
      DO IRAD=1,NRAD
      GFUN(IRAD,LM)=GFUN(IRAD,LM)+CGNT*(DFUNDR(IRAD)-
     &DBLE(L-1)/R(IRAD)*FUN(IRAD,LMY))
      ENDDO
      ENDIF
      IF(L.LT.LMF)THEN
      LMY=(L+1)*(L+2)+M-MY+1
      CGNT=C(0,LM,LMY)*SQPI43*(0.D0,1.D0)
	CALL CDERIV1(FUN(0,LMY),DFUNDR(0),NRAD,H,R(0),DR(0),S)
      DO IRAD=1,NRAD
      GFUN(IRAD,LM)=GFUN(IRAD,LM)+CGNT*(DFUNDR(IRAD)+
     &DBLE(L+2)/R(IRAD)*FUN(IRAD,LMY))
      ENDDO
      ENDIF
      GFUN(0,LM)=GFUN(1,LM)
      ENDDO                            !!! over m
      ENDDO                            !!! over l
	END
