	SUBROUTINE TRANSREL(TREL,LMAX)
***********************************************************
*  Builds transformation matrix which transforms          *
*  spinors of spherical harmonics to relativistic spinors *
***********************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 TREL(2*(LMAX+1)**2,2*(LMAX+1)**2)
	LJM=0
	DO L=0,LMAX
	DO J=2*L-1,2*L+1,2
	DJ=DBLE(J)/2.D0
	IF(J.LT.0)CYCLE
	DO MJ=-J,J,2 ! Mj-1/2
	DMJ=DBLE(MJ)/2.D0
	LJM=LJM+1
	DO ISPIN=1,2
	DO M=-L,L
	LMS=L*(L+1)+M+1+(LMAX+1)**2*(ISPIN-1)
	TREL(LJM,LMS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	IF(J.EQ.2*L-1)THEN
	M=NINT(DMJ-0.5D0)
	LMS=L*(L+1)+M+1
	IF(M.GE.-L)TREL(LJM,LMS)=-SQRT((DJ-DMJ+1.D0)/(2.D0*DJ+2.D0))
	M=NINT(DMJ+0.5D0)
	LMS=L*(L+1)+M+1+(LMAX+1)**2
	IF(M.LE.+L)TREL(LJM,LMS)=+SQRT((DJ+DMJ+1.D0)/(2.D0*DJ+2.D0))
	ELSEIF(J.EQ.2*L+1)THEN
	M=NINT(DMJ-0.5D0)
	LMS=L*(L+1)+M+1
	IF(M.GE.-L)TREL(LJM,LMS)=+SQRT((DJ+DMJ)/(2.D0*DJ))
	M=NINT(DMJ+0.5D0)
	LMS=L*(L+1)+M+1+(LMAX+1)**2
	IF(M.LE.+L)TREL(LJM,LMS)=+SQRT((DJ-DMJ)/(2.D0*DJ))
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	END